// Code generated by go-swagger; DO NOT EDIT.

package environment_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"

	models "gitlab.com/kathra/kathra/kathra-services/kathra-runtimemanager/kathra-runtimemanager-go/kathra-runtimemanager-interface/models"
)

// NewAddRuntimeEnvironmentParams creates a new AddRuntimeEnvironmentParams object
// no default values defined in spec.
func NewAddRuntimeEnvironmentParams() AddRuntimeEnvironmentParams {

	return AddRuntimeEnvironmentParams{}
}

// AddRuntimeEnvironmentParams contains all the bound params for the add runtime environment operation
// typically these are obtained from a http.Request
//
// swagger:parameters addRuntimeEnvironment
type AddRuntimeEnvironmentParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*RuntimeEnvironment to deploy
	  Required: true
	  In: body
	*/
	RuntimeEnvironment *models.RuntimeEnvironment
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewAddRuntimeEnvironmentParams() beforehand.
func (o *AddRuntimeEnvironmentParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	if runtime.HasBody(r) {
		defer r.Body.Close()
		var body models.RuntimeEnvironment
		if err := route.Consumer.Consume(r.Body, &body); err != nil {
			if err == io.EOF {
				res = append(res, errors.Required("runtimeEnvironment", "body"))
			} else {
				res = append(res, errors.NewParseError("runtimeEnvironment", "body", "", err))
			}
		} else {
			// validate body object
			if err := body.Validate(route.Formats); err != nil {
				res = append(res, err)
			}

			if len(res) == 0 {
				o.RuntimeEnvironment = &body
			}
		}
	} else {
		res = append(res, errors.Required("runtimeEnvironment", "body"))
	}
	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
